//*****************************
//Adam Lasko
//9.02.2006 Zbylitowska Gra
//Efekt swiata pochodni
//*****************************
unit Unit1;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, OmegaInput, OmegaTimer, OmegaFont, OmegaImageList, OmegaSprite,
  OmegaScreen;

type
  //*******Plomien****************
  TPlomien=class(TSimpleAnimSprite)
  private
    procedure Draw;override;
   protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem
                       );virtual;

  end;

  //*****POCHODNIA*******************
  TPochodnia=class(TSprite)
   private
    //ponizsze dane mozna odczytac w dowolnym edytorze grafiki np. MSPaint
    czubek:array[0..1]of TPoint;
    swiatlo,
    plomien:TPlomien;
   protected
    dVx,
    dVy:single;//zmienne przyrostu poloenia
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;
                       const ImageListItemPlomien: TImageListItem;
                       const ImageListItemSwiatlo: TImageListItem
                       );virtual;
    procedure Move(const MoveCount: Single); override;
    destructor Destroy;
  end;
  //*********************************
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaSprite1: TOmegaSprite;
    OmegaImageList1: TOmegaImageList;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaInput1: TOmegaInput;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OmegaScreen1Init(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Pochodnia:TPochodnia;

implementation

{$R *.dfm}
//*******PLOMIEN************************************
constructor TPlomien.Create(const AParent: TOmegaSprite;
                            const ImageListItem: TImageListItem
                            );
begin
 //rob plomien
 inherited Create(AParent);
 Image := ImageListItem;
 ImageIndex:=0;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
 AnimPos:=0;
 AnimCount:=10;
 AnimSpeed:=15;
 AnimLooped:=true;
 DoAnimate:=true;
end;

procedure TPlomien.Draw;
begin
 // inherited Draw;//<-- jak to sie wlaczy to mozna zobaczyc roznic- z czego sie zrezygnowalo
 //swiatlo
 Image.Draw(Round(x),Round(y),0,0.5,0.5,1,1,OmegaColor(200,200,100,255),Round(AnimPos),bmSrcAdd);
end;

//*****POCHODNIA*******************************************
constructor TPochodnia.Create(const AParent: TOmegaSprite;
                              const ImageListItem: TImageListItem;
                              const ImageListItemPlomien: TImageListItem;
                              const ImageListItemSwiatlo: TImageListItem);
begin
 //rob drzewce pochodni
 inherited Create(AParent);
 Image := ImageListItem;
 ImageIndex:=0;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
 x:=200;
 y:=250;
 z:=1;
 //pzryjmij wartosc przesuniecia
 dVx:=40;
 //gdy nachylony w prawo
 czubek[0].x:=22;
 czubek[0].y:=12;
 //gdy nachylony w lewo
 czubek[1].x :=12;
 czubek[1].y :=10;
 //rob swiatlo
 Swiatlo:=TPlomien.Create(AParent,ImageListItemSwiatlo);
 Swiatlo.z:=z+1;
 //rob plomien pochodni
 Plomien:=TPlomien.Create(AParent,ImageListItemPlomien);
 Plomien.z:=z+1;
end;

destructor TPochodnia.Destroy;
begin
 Plomien.Dead;
 Swiatlo.Dead;
end;


procedure TPochodnia.Move(const MoveCount: Single);
begin
 inherited Move(MoveCount);
 //uaktualnij polozenie drzewca
 X:= X+MoveCount*dVx;
 if x<0 then begin
    x:=0;    //wyrownaj do lewej krawedzi ekranu
    dVx:=40; //zrob na przesuwanie w prawo
    ImageIndex:=0;//zmien klatke drzewca- nachylona w prawo
    end;
 if x>800 then begin
    x:=800;  //wyrownaj do prawej krawedzi ekranu
    dVx:=-40;//zrob na przesuwanie w prawo
    ImageIndex:=1;//zmien klatke drzewca- nachylona w lewo
    end;
 //uaktualnij polozenie plomienia
 Plomien.x:=x+czubek[ImageIndex].x-Plomien.width div 2;
 Plomien.y:=y+czubek[ImageIndex].y-Plomien.Height;
 //a teraz swiatla
 Swiatlo.x:=x+czubek[ImageIndex].x-Swiatlo.width div 2;
 Swiatlo.y:=y+czubek[ImageIndex].y-Swiatlo.height div 2;
end;
//************************************************
procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin

 if not omegascreen1.CanDraw then exit;
    OmegaInput1.Update;

     //if oisbutton28 in OmegaInput1.keyboard.statesclicked then OmegaScreen1.ToggleFullScreen;

    OmegaScreen1.BeginRender;

    OmegaScreen1.ClearScreen(0,0,0,0);
    //udawaj noc
    OmegaImageList1.ImageList.Items[0].Draw(75,200,0,0,0,1,1,OmegaColor(50,75,70,255),0);


    OmegaSprite1.Draw;
    OmegaSprite1.Move(OmegaTimer1.DeltaSecs);

    OmegaFont1.BeginFont;
    OmegaFont1.Print(30,0, 'www.epomoce.pl ');
    OmegaFont1.Print(30,20,'FPS: '+IntToStr(OmegaTimer1.FPS));
    //OmegaFont1.Print(30,40,'F2- zmiana trybu wywietlania');
    OmegaFont1.EndFont;

    OmegaScreen1.EndRender;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.Init;
  OmegaScreen1.SetHWnd(self.handle);

  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',8,[]);
  OmegaFont1.Color:=OmegaColor(0,255,0);
end;

procedure TForm1.OmegaScreen1Init(Sender: TObject);
begin
  //Tworz pochodnie,
  // W liscie obrazow pod indeksem 1 jest drzewce pochodni, pod indeksem 2 jest plomie,
  // pod indeksem 3 jest obraz swiatla
  Pochodnia:=TPochodnia.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[1],OmegaImageList1.ImageList.Items[2],OmegaImageList1.ImageList.Items[3]);
  OmegaTimer1.Enabled:=true;
end;

end.
